using System;
using System.Net;
using System.Web.Services.Protocols;

public class XmlWebServiceCaller<TWebService, TReturn>
    where TWebService : SoapHttpClientProtocol, IDisposable, new()
{
    //  ŗLXML WebT[rXĂяodelegateD
    public delegate TReturn CallXmlWebServiceAux(TWebService webService);

    public TReturn CallXmlWebService(CallXmlWebServiceAux callXmlWebServiceAux)
    {
        using (TWebService ws = new TWebService())
        {
            ws.Credentials = CredentialCache.DefaultCredentials;

            //  delegategpXML WebT[rXĂяo܂D
            return callXmlWebServiceAux(ws);
        }
    }
}

public class List8
{
    public void Do()
    {
        int x = 1;
        int y = 2;

        //  GenericsAnonymous Methodsgݍ킹āC
        //  vWFNg̓Ǝ[ɏ]XML WebT[rXĂяo܂D

        //  X^ǔ^Ɩ߂ľ^w肵ăCX^XD
        int z = new XmlWebServiceCaller<localhost.MyWebService, int>().CallXmlWebService(
            //  ŗLXML WebT[rXĂяoAnonymous MethodD
            delegate(localhost.MyWebService webService)
            {
		//  Anonymous MethodsȂAxyRȈʒuɏ܂B
                return webService.Add(x, y);
            });
        
        Console.Out.WriteLine(z);
    }
}
