using System;
using System.Web;

public class HotTopicObjectDataSource
{
    //  rWlXECƒʐM邽߂̌^tDataSet
    private CatalogDataSet catalogDataSet;

	public HotTopicObjectDataSource()
	{
        //  ZbV^tDataSet擾B
        catalogDataSet = (CatalogDataSet)HttpContext.Current.Session["CatalogDataSet"];

        //  ^tDataSetZbVɂȂꍇ́cc
        if (catalogDataSet == null)
        {
            //  ^tDataSet𐶐B
            catalogDataSet = new CatalogDataSet();

            //  rWlXEWbNECĂяoăf[^擾B
            //  ͎蔲TableAdapter𒼐ڌĂяo܂B
            new CatalogDataSetTableAdapters.HotTopicTableAdapter().Fill(catalogDataSet.HotTopic);

            //  ZbVɌ^tDataSeti[B
            HttpContext.Current.Session["CatalogDataSet"] = catalogDataSet;
        }
	}

    //  SELECTɑ郁\bh
    public CatalogDataSet.HotTopicDataTable GetHotTopics()
    {
        return catalogDataSet.HotTopic;
    }

    //  DELETEɑ郁\bh
    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Delete, true)]
    public void DeleteHotTopic(int hotTopicCode)
    {
        catalogDataSet.HotTopic.FindByHotTopicCode(hotTopicCode).Delete();
    }

    //  INSERTɑ郁\bh
    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Insert, true)]
    public void InsertHotTopic(int hotTopicCode, DateTime lastUpdateTime, string caption, string description, string uri)
    {
        catalogDataSet.HotTopic.AddHotTopicRow(hotTopicCode, lastUpdateTime, caption, description, uri);
    }

    //  UPDATEɑ郁\bh
    [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Update, true)]
    public void Update(int hotTopicCode, DateTime lastUpdateTime, string caption, string description, string uri)
    {
        catalogDataSet.HotTopic.FindByHotTopicCode(hotTopicCode).LastUpdateTime = lastUpdateTime;
        catalogDataSet.HotTopic.FindByHotTopicCode(hotTopicCode).Caption = caption;
        catalogDataSet.HotTopic.FindByHotTopicCode(hotTopicCode).Description = description;
        catalogDataSet.HotTopic.FindByHotTopicCode(hotTopicCode).Uri = uri;
    }
}
