using System;
using System.Net;
using System.Web.Services.Protocols;

//  vWFNg̓Ǝ[ɏ]XML WebT[rXĂяo[eBeBD
public abstract class XmlWebServiceCaller<TWebService, TReturn>
    //  TWebServicéCCredentialsݒ肵Cusingň͂C
    //  ŃRXgNg肷Kv̂ŁC
    //  whereāCSoapHttpClientProtocol̃TuNXŁC
    //  IDisposableĂāC̃RXgN^悤
    //  Lq܂D
    where TWebService : SoapHttpClientProtocol, IDisposable, new()
{
    //  vWFNg̓Ǝ[ɏ]XML WebT[rXĂяoTemplate MethodD
    public TReturn CallXmlWebService()
    {
        //  XML WebT[rXւ̃X^u𐶐D
        using (TWebService ws = new TWebService())
        {
            //  WindowsF؂ɑΉ邽߂ɁCCredentialsݒD
            ws.Credentials = CredentialCache.DefaultCredentials;

            //  ̓IXML WebT[rXĂяóCTuNXŒ`܂D
            return CallXmlWebServiceAux(ws);
        }
    }

    //  TuNXŃI[o[ChŗLXML WebT[rXĂяo\bhD
    protected abstract TReturn CallXmlWebServiceAux(TWebService webService);
}

//  ŗLXML WebT[rXĂяoۃNXD
public class MyWebServiceCaller : XmlWebServiceCaller<localhost.MyWebService, int>
{
    //  XML WebT[rXĂяô߂̈D
    private int x;
    private int y;

    public MyWebServiceCaller(int x, int y)
    {
        this.x = x;
        this.y = y;
    }

    //  MyWebServicěĂяoD
    protected override int CallXmlWebServiceAux(localhost.MyWebService webService)
    {
        return webService.Add(x, y);
    }
}

public class List7
{
    public void Do()
    {
        int x = 1;
        int y = 2;

        //  vWFNg̓Ǝ[ɏ]XML WebT[rXĂяo܂D
        int z = new MyWebServiceCaller(x, y).CallXmlWebService();

        Console.Out.WriteLine(z);
    }
}
