using System;
using System.Diagnostics;
using System.Globalization;

public static class UnitTestUtility
{
    private const string databaseProjectDirectory = @"..\..\..\DatabaseProject\";

    public static void ExecuteCreateScript(string sqlFileName)
    {
        ExecuteScript(string.Format(CultureInfo.CurrentCulture, 
            @"{0}Create Scripts\{1}", databaseProjectDirectory, sqlFileName));
    }

    public static void ExecuteChangeScript(string sqlFileName)
    {
        ExecuteScript(string.Format(CultureInfo.CurrentCulture, 
            @"{0}Change Scripts\{1}", databaseProjectDirectory, sqlFileName));
    }

    private static void ExecuteScript(string sqlFileName)
    {
        Process.Start("osql", string.Format(CultureInfo.CurrentCulture, 
            @"-E -S .\SQLExpress -i ""{0}""", sqlFileName)).WaitForExit();
    }
}
